package com.sheep.gamegroup.presenter;

import com.alibaba.fastjson.JSONObject;
import com.sheep.gamegroup.model.api.ApiService;
import com.sheep.gamegroup.model.entity.BaseMessage;
import com.sheep.gamegroup.model.util.SheepSubscriber;
import com.sheep.jiuyan.samllsheep.SheepApp;

import javax.inject.Inject;

import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.schedulers.Schedulers;

/**
 * Created by ljy on 2018/3/18.
 */

public class RechargeQPresenter implements RechargeQContract.Presenter {

    private RechargeQContract.View view;
    private ApiService apiService;

    @Inject
    public RechargeQPresenter(RechargeQContract.View view, ApiService apiService) {
        this.view = view;
        this.apiService = apiService;
    }

    @Override
    public void goRechargeQ(JSONObject jsonObject) {
        apiService.goRechargeQ(jsonObject)
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new SheepSubscriber<BaseMessage>(SheepApp.getInstance()) {
                    @Override
                    public void onError(BaseMessage baseMessage) {
                        view.failRechargeQ(baseMessage);
                    }

                    @Override
                    public void onNext(BaseMessage baseMessage) {
                        view.succRechargeQ(baseMessage);
                    }
                });
    }

}
